# PhasicFlow: checkStatic< T >::has_static_member_TYPENAME< testType, Ret(Args...)> Struct Template Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

checkStatic< T >::has_static_member_TYPENAME< testType, Ret(Args...)> Struct Template Reference

## Classes

struct | Check

## Static Public Member Functions

template<typename U >
static std::true_type | Test (Check< Ret(*)(Args...), &U::TYPENAME > *)
template<typename U >
static std::false_type | Test (...)

## Static Public Attributes

static const bool | value = decltype(Test<testType>(0))::value

## Detailed Description

### template<typename T>
template<typename testType, typename Ret, typename... Args>
struct pFlow::checkStatic< T >::has_static_member_TYPENAME< testType, Ret(Args...)>

Definition at line 52 of file typeInfo.hpp.

## Member Function Documentation

## Test() [1/2]

static std::true_type Test | ( | Check< Ret(*)(Args...), &U::TYPENAME > * |  | ) |

static

## Test() [2/2]

static std::false_type Test | ( |  | ... | ) |

static

## Member Data Documentation

## value

const bool value = decltype(Test<testType>(0))::value

static

Definition at line 52 of file typeInfo.hpp.

The documentation for this struct was generated from the following file:

- src/phasicFlow/typeSelection/typeInfo.hpp